﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread;

namespace spread_win_custominputmap
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            fpSpread1.ActiveSheet.Columns[0].CanFocus = false;
            InputMap im = fpSpread1.GetInputMap(InputMapMode.WhenFocused);
            ActionMap am = fpSpread1.GetActionMap();
            im.Put(new Keystroke(Keys.Home, Keys.Control), "NewControlHomeAction");
            am.Put("NewControlHomeAction", new NewControlHomeAction());
        }
    }

    /// <summary>
    /// 默认情况下 Ctrl + Home 即选择Cell[0,0]，自定义动作实现选择 Cell[0,1]
    /// </summary>
    public class NewControlHomeAction : FarPoint.Win.Spread.Action
    {
        public override void PerformAction(object source)
        {
            if (source is SpreadView)
            {
                SpreadView spreadView = (SpreadView)source;
                spreadView.Sheets[spreadView.ActiveSheetIndex].SetActiveCell(0, 1);
                spreadView.ShowActiveCell(VerticalPosition.Top, HorizontalPosition.Left);
            }
        }
    }
}
